package cn.ibizlab.assetmanagement.core.plan.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.plan.domain.EAMPlanLine;
import cn.ibizlab.assetmanagement.core.plan.filter.EAMPlanLineSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMPlanLine] 服务对象接口
 */
public interface IEAMPlanLineService extends IService<EAMPlanLine>{

    boolean create(EAMPlanLine et) ;
    void createBatch(List<EAMPlanLine> list) ;
    boolean update(EAMPlanLine et) ;
    void updateBatch(List<EAMPlanLine> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMPlanLine get(String key) ;
    EAMPlanLine getDraft(EAMPlanLine et) ;
    boolean checkKey(EAMPlanLine et) ;
    boolean save(EAMPlanLine et) ;
    void saveBatch(List<EAMPlanLine> list) ;
    Page<EAMPlanLine> searchDefault(EAMPlanLineSearchContext context) ;
    List<EAMPlanLine> selectByAssetid(String assetid) ;
    void removeByAssetid(String assetid) ;
    List<EAMPlanLine> selectByEamlocationid(String eamlocationid) ;
    void removeByEamlocationid(String eamlocationid) ;
    List<EAMPlanLine> selectByEamplanid(String eamplanid) ;
    void removeByEamplanid(String eamplanid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMPlanLine> getEamplanlineByIds(List<String> ids) ;
    List<EAMPlanLine> getEamplanlineByEntities(List<EAMPlanLine> entities) ;
}


